library dartdb;

class Database{
  
  Database(void build(DatabaseBuilder builder)){
    build(new DatabaseBuilder(this));
  }
  
  void transaction(void processes(Transaction t)){
    var t = new Transaction();
    processes(t);
  }
}

abstract class Table{

}

abstract class Column<T>{
  
}

abstract class IDColumn extends Column<int>{
  
}

abstract class IntColumn extends Column<int>{
  
}

abstract class StringColumn extends Column<String>{
  
}

abstract class DateTimeColumn extends Column<DateTime>{
  
}

class ReferenceColumn extends Column{
  
  Column _reference;
  Column get reference => _reference; 
  
}

class DatabaseBuilder{
  Database _db;
  DatabaseBuilder(this._db);
  
  void createTable(void build(TableBuilder bulder) ){
    build(new TableBuilder());
  }
  
}

class TableBuilder{
  
  Column _addColumn(ColumnBuilder builder , void build(ColumnBuilder builder)){
    build(builder);
    return builder._column;
  }
  
  IDColumn        addIDColumn       (void build(IDColumnBuilder        builder))  => _addColumn(new IDColumnBuilder(),       build);
  StringColumn    addStringColumn   (void build(StringColumnBuilder    builder))  => _addColumn(new StringColumnBuilder(),   build);
  IntColumn       addIntColumn      (void build(IntColumnBuilder       builder))  => _addColumn(new IntColumnBuilder(),      build);
  ReferenceColumn addReferenceColumn(Column reference,void build(ReferenceColumnBuilder builder)) 
    => _addColumn(new ReferenceColumnBuilder(reference),build);
  
}


abstract class ColumnBuilder{
  Column _column;
}

class IDColumnBuilder        extends ColumnBuilder{
  
}
class StringColumnBuilder    extends ColumnBuilder{
  
}

class IntColumnBuilder       extends ColumnBuilder{
  
}
class ReferenceColumnBuilder extends ColumnBuilder{
  
  ReferenceColumn _column = new ReferenceColumn();
  
  ReferenceColumnBuilder(Column reference){
    _column._reference = reference;
  }

}

class Transaction{
  
}

class Select{
  
}

class Update{
  
}

class Insert{
  
}

class Delete{
  
}